Bug 593082 - ext4: upstream updates
ext4: upstream updates
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel (Show other bugs)
6.0
All Linux
low Severity medium
: rc
: ---
Assigned To: Eric Sandeen
Petr Beňas
:
Depends On:
Blocks: 534150
  Show dependency treegraph
 
Reported: 2010-05-17 15:14 EDT by Eric Sandeen
Modified: 2015-01-04 17:59 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-11-11 11:11:17 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Eric Sandeen 2010-05-17 15:14:44 EDT
Several upstream bugfixes for ext4 & jbd2 exist, and we should pull them back to rhel6.  Opening the bug as a placeholder for now, will add a list of upstream commits soon, after testing.

-Eric
Comment 1 RHEL Product and Program Management 2010-05-17 15:25:48 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux major release.  Product Management has requested further
review of this request by Red Hat Engineering, for potential inclusion in a Red
Hat Enterprise Linux Major release.  This request is not yet committed for
inclusion.
Comment 3 Aristeu Rozanski 2010-05-25 13:43:48 EDT
Patch(es) available on kernel-2.6.32-29.el6
Comment 6 Petr Beňas 2010-07-02 05:46:56 EDT
VERIFIED Sanity only. All the patches present in 2.6.32-29 and ext4 working on 2.6.32-30.
$ git log --pretty=oneline kernel-2.6.32-28.el6..kernel-2.6.32-29.el6 contains:
fd08d265ed8b7152b288b5f3f91ea34b0a34d436 [fs] ext4: correctly calculate number of blocks for fiemap
54146091efba58ec49f9678af3677b8d40fb8f85 [fs] ext4: make "offset" consistent in ext4_check_dir_entry()
755dbeae356c97ba9a13a4cb1e131e59dd1ddf30 [fs] ext4: Fix estimate of # of blocks needed to write indirect-mapped files
0d74cd3d7e34573333a136de7b5b54226d50677a [fs] ext4: add missing error checking to ext4_expand_extra_isize_ea()
b152b1ecf9c73381069ef5eae86477c40ad2b6ea [fs] ext4: Release page references acquired in ext4_da_block_invalidatepages
6d5468e2c800e4decfebd9f7124d359b804bd5a5 [fs] ext4: Fixed inode allocator to correctly track a flex_bg's used_dirs
443322df416ffbf28a8f5db4dc841bf18c163791 [fs] ext4: Use bitops to read/modify EXT4_I(inode)->i_state
80b468d329083d02368cc7b3f308fc1bd2d69bb6 [fs] jbd2: delay discarding buffers in journal_unmap_buffer
2916ccb75158320ef3828f1bfe7fe971d6435238 [fs] ext4: move __func__ into a macro for ext4_warning, ext4_error
2441544975518bc87f89616de1f39597343f703d [fs] jbd2: don't use __GFP_NOFAIL in journal_init_common()
95415125fa244a39c3e9f1bcf3728179885f01bf [fs] ext4: return correct wbc.nr_to_write in ext4_da_writepages
a990bfa3137f5887571d6ff9cbb1edb0fd34a547 [fs] ext4: Convert BUG_ON checks to use ext4_error() instead
8547b01ca61d705a076c2f0df2adfbc7a1700686 [fs] ext4: Fix BUG_ON at fs/buffer.c:652 in no journal mode
3e20df4c4b2e4442ea1d867bc230214fddc0d1d7 [fs] ext4: Drop EXT4_GET_BLOCKS_UPDATE_RESERVE_SPACE flag
0d369ebae0393fcc84ee8afc481b7a2a9e0ccdd2 [fs] jbd: jbd-debug and jbd2-debug should be writable
132f18203fa21a864a90dae64b5430ec5d728a76 [fs] ext4: replace BUG() with return -EIO in ext4_ext_get_blocks
9d40d70acaf950e223aff9af80ec80c688a3d1e7 [fs] ext4: Use slab allocator for sub-page sized allocations
d67ae4e6245dc547e15a09bedb79a8a46e2b31ad [fs] ext4: explicitly remove inode from orphan list after failed direct io
f3f3bd4254863f89542a324ed621a7ce4a1e3e1a [fs] ext4: Handle non empty on-disk orphan link
966ba4e95305b7a6e552721c6e810bf0bfd26b84 [fs] ext4: fix up rb_root initializations to use RB_ROOT
28c90912f4122e49da8779af98c79bc63c7390ee [fs] ext4: Fix fencepost error in chosing choosing group vs file preallocation

all this commits are corresponding with patches from comment 4.

xfstests succeeded on ext4 on 2.6.32-30.el6.x86_64:
rch.rpm ll-pesc1425-02 ~]# rpm -i rh-tests-kernel-filesystems-xfstests-1.0-6.noar                                          
[root@dell-pesc1425-02 ~]# cd /mnt/tests/kernel/filesystems/xfstests/                                                      
[root@dell-pesc1425-02 xfstests]# export TEST_PARAM_FSTYP=ext4
[root@dell-pesc1425-02 xfstests]# make run > result
[root@dell-pesc1425-02 xfstests]# grep 'PASS' result | wc -l
160
[root@dell-pesc1425-02 xfstests]# grep 'FAIL' result | wc -l
1
This is the fail:
105	 - output mismatch (see 105.out.bad)
--- 105.out	2010-07-02 04:53:09.000000000 -0400
+++ 105.out.bad	2010-07-02 05:08:07.017815883 -0400
@@ -1,3 +1,3 @@
 QA output created by 105
--rw-r--r-- root
--rw-r--r-- root
+-rw-r--r--. root
+-rw-r--r--. root
Ran: 105
Failures: 105
Failed 1 of 1 tests
=== 105.full ===
/mnt/testarea/test/syscalltest [u::rw-,g::r--,o::r--]
*** MKFS ***

mke2fs 1.41.12 (17-May-2010)
=== 105.out.bad ===
QA output created by 105
-rw-r--r--. root
-rw-r--r--. root
/kernel/filesystems/xfstests/105 result: FAIL
   metric: 0
   Log: /tmp/tmp.8T3XbH
   DMesg: /tmp/dmesg.log

[root@dell-pesc1425-02 xfstests]# cd /var/lib/xfstests/
[root@dell-pesc1425-02 xfstests]# ./check 105
mount: /dev/loop0: can't read superblock
common.rc: retrying test device mount with external set
mount: /dev/loop0: can't read superblock
common.rc: could not mount /dev/loop0 on /mnt/testarea/test

This does not look like ext4 fault.
Comment 7 releng-rhel@redhat.com 2010-11-11 11:11:17 EST
Red Hat Enterprise Linux 6.0 is now available and should resolve
the problem described in this bug report. This report is therefore being closed
with a resolution of CURRENTRELEASE. You may reopen this bug report if the
solution does not work for you.

Note You need to log in before you can comment on or make changes to this bug.